#!/usr/bin/env python

# should also look for things other than assertions:
#   "malloc" (more specifically: "szone_error" for OOM, "MallocHelp" for double free, i think)
#   "NSRunLoop ignoring exception" (going away -- bug 163260, bug 340453)
#   "Wrong parent style context" (in stdout!) (https://bugzilla.mozilla.org/show_bug.cgi?id=374297#c11)

def getAssertions():
    filenum = 0
    
    # map from (assertion message) to (list of files containing it)
    filesWithAssertion = {}

    while 1:
        filenum += 1
    
        try:
            currentFile = open("err-w" + str(filenum), "r")
        except IOError:
            print "Can't find " + str(filenum) + " so I guess I'm done"
            break
        
        # map from (assertion message) to (true, if seen in the current file)
        seenInCurrentFile = {}
    
        for line in currentFile:
            line = line.strip("\x07").rstrip("\n")
            if (line.startswith("###!!!") and not (line in seenInCurrentFile)):
                seenInCurrentFile[line] = True
                if not (line in filesWithAssertion):
                    filesWithAssertion[line] = []
                filesWithAssertion[line].append("w" + str(filenum))

        currentFile.close()
        
    return filesWithAssertion

def getIgnores():
    ignoreList = []
    ignoreFile = open("known_assertions.txt", "r")

    for line in ignoreFile:
        line = line.strip()
        if ((len(line) > 0) and not line.startswith("#")):
            ignoreList.append(line)

    return ignoreList
        

def ignore(ignoreList, assertion):
    for ig in ignoreList:
        if (assertion.find(ig) != -1):
            return True
    return False


filesWithAssertion = getAssertions()

ignoreList = getIgnores()

# for i in ignoreList:
#  print "*", i

for assertion in filesWithAssertion:
    if (not ignore(ignoreList, assertion)):
        print ""
        print " ".join(filesWithAssertion[assertion])
        print assertion
        
print ""
