#!/usr/bin/env python


knownArray = [

# bug 102229 -- DNS service leak -- let's make "nsDNSService" be considered
# a "large object" instead of listing all of these things here!
#"StringAdopt",
#"mozStorageConnection",
#"mozStorageService",
#"mozStorageStatement",
#"nsBaseAppShell",
#"nsBaseURLParser",
#"nsCacheSession",
#"nsCategoryObserver",
#"nsCookiePermission",
#"nsCookieService",
## "nsDNSService",
#"nsDocNavStartProgressListener",
#"nsDocShell::InterfaceRequestorProxy",
#"nsHashPropertyBag",
#"nsHashtable",
#"nsHttpChannel",
#"nsHttpHandler",
#"nsIDNService",
#"nsIOService",
#"nsLoadGroup",
#"nsLocalFile",
#"nsObserverService",
#"nsPermissionManager",
#"nsRunnable",
#"nsSocketTransportService",
#"nsStandardURL",
#"nsTArray_base",
#"nsThread",
#"nsTimerImpl",
#"nsUnicodeNormalizer",
#"nsVariant",
#"nsWeakReference",
## "nsVoidArray",
## "nsStringBuffer",

# bug 102229, sometimes these additional objects leak
#"nsDNSAsyncRequest",
#"nsHostRecord",
#"nsHostResolver",
#"nsHttpConnection",
#"nsSocketTransport",

# even more bug 102229?
#"nsStreamConverterService",

# bug 391976
"nsMathMLContainerFrame",
"nsMathMLmtableOuterFrame",
"nsMathMLmtdInnerFrame",
"nsMathMLmactionFrame",

# Bug 397206 --> large object BackstagePass
#"BackstagePass",
#"XPCNativeScriptableShared",
#"XPCWrappedNative",
#"XPCWrappedNativeProto",
#"nsArray",
#"nsJSID",
#"nsSAXAttributes",
#"nsSystemPrincipal",
#"nsXPCWrappedJS",
#"nsXPCWrappedJSClass",
#"xptiInterfaceInfo",

# Bug 398462
"nsBaseAppShell",
"nsRunnable",

# Bug 400926
"nsSimpleNestedURI"

]

knownHash = {}
for s in knownArray:
  knownHash[s] = True

filenum = 0

while 1:
    filenum += 1
    filename = "w" + str(filenum)

    try:
        currentFile = open(filename, "r")
    except IOError:
        print "Can't find " + filename + " so I guess I'm done"
        break
    
    for line in currentFile:
        line = line.strip("\x07").rstrip("\n")
        if (line.startswith("nsTraceRefcntImpl::DumpStatistics")):
            break
    else:
        currentFile.close()
        continue
        
    smallLeaks = ""
    largeLeaks = ""

    for line in currentFile:
        line = line.strip("\x07").rstrip("\n").lstrip(" ")
        if (line == "nsStringStats"):
            break
        a = line.split(" ")[1]
        if a in ("nsDocument", "nsGlobalWindow", "nsDocShell", "nsGenericElement", "nsDNSService", "BackstagePass"):
            largeLeaks += "*** Large object " + a + "\n"
        if not a in knownHash:
            smallLeaks += a + "\n"

    if largeLeaks != "":
        print filename + ":\n" + largeLeaks
    elif smallLeaks != "":
        print filename + ":\n" + smallLeaks
            
    currentFile.close()
